## gimpproceduraldb

gimpproceduraldb — Functions for querying and changing procedural database (PDB) entries.

## Functions

gchar * | gimp_procedural_db_temp_name ()
gboolean | gimp_procedural_db_get_data ()
gboolean | gimp_procedural_db_set_data ()
gboolean | gimp_procedural_db_dump ()
gboolean | gimp_procedural_db_query ()
gboolean | gimp_procedural_db_proc_exists ()
gboolean | gimp_procedural_db_proc_info ()
gboolean | gimp_procedural_db_proc_arg ()
gboolean | gimp_procedural_db_proc_val ()
gint | gimp_procedural_db_get_data_size ()

## Description

Functions for querying and changing procedural database (PDB) entries.

## Functions

### gimp_procedural_db_temp_name ()

    gchar *
    gimp_procedural_db_temp_name (void);

Generates a unique temporary PDB name.

This procedure generates a temporary PDB entry name that is guaranteed to be unique.

#### Returns

A unique temporary name for a temporary PDB entry.

### gimp_procedural_db_get_data ()

    gboolean
    gimp_procedural_db_get_data (const gchar *identifier,
                                 gpointer data);

Returns data associated with the specified identifier.

This procedure returns any data which may have been associated with the specified identifier. The data is copied into the given memory location.

#### Parameters

identifier | The identifier associated with data. |
data | A byte array containing data. |

#### Returns

TRUE on success, FALSE if no data has been associated with the identifier

### gimp_procedural_db_set_data ()

    gboolean
    gimp_procedural_db_set_data (const gchar *identifier,
                                 gconstpointer data,
                                 guint32 bytes);

Associates the specified identifier with the supplied data.

This procedure associates the supplied data with the provided identifier. The data may be subsequently retrieved by a call to 'procedural-db-get-data'.

#### Parameters

identifier | The identifier associated with data. |
data | A byte array containing data. |
bytes | The number of bytes in the data |

#### Returns

TRUE on success.

### gimp_procedural_db_dump ()

    gboolean
    gimp_procedural_db_dump (const gchar *filename);

Dumps the current contents of the procedural database

This procedure dumps the contents of the procedural database to the specified file. The file will contain all of the information provided for each registered procedure.

#### Parameters

filename | The dump filename. |

#### Returns

TRUE on success.

### gimp_procedural_db_query ()

    gboolean
    gimp_procedural_db_query (const gchar *name,
                              const gchar *blurb,
                              const gchar *help,
                              const gchar *author,
                              const gchar *copyright,
                              const gchar *date,
                              const gchar *proc_type,
                              gint *num_matches,
                              gchar ***procedure_names);

Queries the procedural database for its contents using regular expression matching.

This procedure queries the contents of the procedural database. It is supplied with seven arguments matching procedures on { name, blurb, help, author, copyright, date, procedure type}. This is accomplished using regular expression matching. For instance, to find all procedures with \"jpeg\" listed in the blurb, all seven arguments can be supplied as \".*\", except for the second, which can be supplied as \".*jpeg.*\". There are two return arguments for this procedure. The first is the number of procedures matching the query. The second is a concatenated list of procedure names corresponding to those matching the query. If no matching entries are found, then the returned string is NULL and the number of entries is 0.

#### Parameters

name | The regex for procedure name. |
blurb | The regex for procedure blurb. |
help | The regex for procedure help. |
author | The regex for procedure author. |
copyright | The regex for procedure copyright. |
date | The regex for procedure date. |
proc_type | The regex for procedure type: { 'Internal GIMP procedure', 'GIMP Plug-in', 'GIMP Extension', 'Temporary Procedure' }. |
num_matches | The number of matching procedures. |
procedure_names | The list of procedure names. |

#### Returns

TRUE on success.

### gimp_procedural_db_proc_exists ()

    gboolean
    gimp_procedural_db_proc_exists (const gchar *procedure_name);

Checks if the specified procedure exists in the procedural database

This procedure checks if the specified procedure is registered in the procedural database.

#### Parameters

procedure_name | The procedure name. |

#### Returns

Whether a procedure of that name is registered.

Since: 2.6

### gimp_procedural_db_proc_info ()

    gboolean
    gimp_procedural_db_proc_info (const gchar *procedure,
                                  gchar **blurb,
                                  gchar **help,
                                  gchar **author,
                                  gchar **copyright,
                                  gchar **date,
                                  GimpPDBProcType *proc_type,
                                  gint *num_args,
                                  gint *num_values,
                                  GimpParamDef **args,
                                  GimpParamDef **return_vals);

Queries the procedural database for information on the specified procedure.

This procedure returns information on the specified procedure. A short blurb, detailed help, author(s), copyright information, procedure type, number of input, and number of return values are returned. Additionally this function returns specific information about each input argument and return value.

#### Parameters

procedure | The procedure name. |
blurb | A short blurb. |
help | Detailed procedure help. |
author | Author(s) of the procedure. |
copyright | The copyright. |
date | Copyright date. |
proc_type | The procedure type. |
num_args | The number of input arguments. |
num_values | The number of return values. |
args | The input arguments. |
return_vals | The return values. |

#### Returns

TRUE on success.

### gimp_procedural_db_proc_arg ()

    gboolean
    gimp_procedural_db_proc_arg (const gchar *procedure_name,
                                 gint arg_num,
                                 GimpPDBArgType *arg_type,
                                 gchar **arg_name,
                                 gchar **arg_desc);

Queries the procedural database for information on the specified procedure's argument.

This procedure returns information on the specified procedure's argument. The argument type, name, and a description are retrieved.

#### Parameters

procedure_name | The procedure name. |
arg_num | The argument number. |
arg_type | The type of argument. |
arg_name | The name of the argument. |
arg_desc | A description of the argument. |

#### Returns

TRUE on success.

### gimp_procedural_db_proc_val ()

    gboolean
    gimp_procedural_db_proc_val (const gchar *procedure_name,
                                 gint val_num,
                                 GimpPDBArgType *val_type,
                                 gchar **val_name,
                                 gchar **val_desc);

Queries the procedural database for information on the specified procedure's return value.

This procedure returns information on the specified procedure's return value. The return value type, name, and a description are retrieved.

#### Parameters

procedure_name | The procedure name. |
val_num | The return value number. |
val_type | The type of return value. |
val_name | The name of the return value. |
val_desc | A description of the return value. |

#### Returns

TRUE on success.

### gimp_procedural_db_get_data_size ()

    gint
    gimp_procedural_db_get_data_size (const gchar *identifier);

Returns size of data associated with the specified identifier.

This procedure returns the size of any data which may have been associated with the specified identifier. If no data has been associated with the identifier, an error is returned.

#### Parameters

identifier | The identifier associated with data. |

#### Returns

The number of bytes in the data.